#include "wnd.h"
#include "ui_wnd.h"
#include <QtNetwork>

// Debugging
#include<QtDebug>

wnd::wnd(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::wndClass)
{
    qDebug("Hello, world!");

    ui->setupUi(this);
    qDebug("UI setted");

    QStringList translates, list;
    list
    <<"sq"  <<"ar"  <<"bg"  <<"ca"
    <<"zh-CN"   <<"zh-TW"   <<"hr"
    <<"cs"  <<"da"  <<"nl"  <<"en"
    <<"et"  <<"tl"  <<"fi"  <<"fr"
    <<"gl"  <<"de"  <<"el"  <<"iw"
    <<"hi"  <<"hu"  <<"id"  <<"it"
    <<"ja"  <<"ko"  <<"lv"  <<"lt"
    <<"mt"  <<"no"  <<"pl"  <<"pt"
    <<"ro"  <<"ru"  <<"sr"  <<"sk"
    <<"sl"  <<"es"  <<"sv"  <<"th"
    <<"tr"  <<"uk"  <<"vi";
    translates
    <<"Albanian"  <<"Arabic"  <<"Bulgarian"  <<"Catalan"
    <<"Chinese (Simplified)"   <<"Chinese (Traditional)"   <<"Croatian"
    <<"Czech"  <<"Danish"  <<"Dutch"  <<"English"
    <<"Estonian"  <<"Filipino"  <<"Finnish"  <<"French"
    <<"Galician"  <<"German"  <<"Greek"  <<"Hebrew"
    <<"Hindi"  <<"Hungarian"  <<"Indonesian"  <<"Italian"
    <<"Japanese"  <<"Korean"  <<"Latvian"  <<"Lithuanian"
    <<"Maltese"  <<"Norwegian"  <<"Polish"  <<"Portuguese"
    <<"Romanian"  <<"Russian"  <<"Serbian"  <<"Slovak"
    <<"Slovenian"  <<"Spanish"  <<"Swedish"  <<"Thai"
    <<"Turkish"  <<"Ukrainian"  <<"Vietnamese";

    langs = new QStringList(list);

    ui->langFrom->addItems(translates);
    ui->langTo->addItems(translates);
    qDebug("Langs setted");

    for(int i=0;i<ui->langFrom->count();i++)
    {
        QString path = QString(":/flags/res/flags/%1.png").arg(langs->at(i));
        ui->langFrom->setItemIcon(i,QIcon(path));
        ui->langTo->setItemIcon(i,QIcon(path));

        //ui->textFrom->append(icon);
    }
    qDebug("Lang flags configured...");

    ui->langFrom->setCurrentIndex(settings.value("lang/from",0).value<int>());
    ui->langTo->setCurrentIndex(settings.value("lang/to",0).value<int>());
    qDebug("Last pair loaded");

    ui->textTo->setReadOnly(true);

    http = new QHttp(this);
    qDebug("Http protocol initialized.");

    connect(ui->swap,SIGNAL(clicked()),this,SLOT(swap()));
    connect(ui->translate,SIGNAL(clicked()),this,SLOT(translate()));
    connect(http, SIGNAL(done(bool)), this, SLOT(done()));
    qDebug("All buttons are connected");
}
wnd::~wnd()
{
    settings.setValue("lang/from",ui->langFrom->currentIndex());
    settings.setValue("lang/to",ui->langTo->currentIndex());
    qDebug("Last language pair saved");

    qDebug("Good bye.");
    delete ui;
}

void wnd::swap()
{
    int tmp = ui->langTo->currentIndex();
    ui->langTo->setCurrentIndex( ui->langFrom->currentIndex() );
    ui->langFrom->setCurrentIndex( tmp );
    qDebug("Languages selector swaped.");
}
void wnd::translate()
{
    qDebug("Starting translation.");
    QString from, to, text;

    from = langs->at( ui->langFrom->currentIndex() );
    to = langs->at( ui->langTo->currentIndex() );
    text = ui->textFrom->toPlainText();
    qDebug("Now we know all we need.");

    QString url = QString("/translate_a/t?client=t&sl=" + from + "&tl=" + to);
    qDebug("Url configured.");

    QHttpRequestHeader header = QHttpRequestHeader("POST", url, 1, 1);
        header.setValue("Host", "www.google.com");
        header.setValue("User-Agent", "Mozilla/5.0");
        header.setValue("Accept-Encoding", "deflate");
        header.setContentLength(text.length());
        header.setValue("Connection", "Close");
    qDebug("Headers configured.");

    QByteArray ba("text=");
        ba.append( text.toUtf8() );
    qDebug("ByteArray completed.");

    http->setHost("www.google.com");
    qDebug("HTTP host setted");

    http->request(header,ba);
    qDebug("Request started");
}
void wnd::done()
{
    qDebug("HTTP Request done.");

    QString text;
    text = text.fromUtf8( http->readAll() );
    qDebug("All data is readed.");

    text = text.replace(QString("\\\""),QString("\""));
    text = text.replace(QString("\\n"),QString("\n"));
    if( text.startsWith( QString("\"") ) ) {
        qDebug("This is a text.");
        text = text.remove( text.length()-1, 1).remove(0,1);
    } else if( text.startsWith( QString("[") ) && text.endsWith( QString("]") ) ) {
        qDebug("This is a word.");
        QStringList tra;
        //tra = text.split(QRegExp(QString("\"(.*)\"")));
        text = text.replace(QString("]"),QString(""));
        tra = text.split(QString("["));
        text = QString("");
        for(int i=0;i<tra.count();i++)
        {
            text.append( tra.at(i) );
            text.append( "\n" );
        }
    }

    qDebug("All operations done. Setting text to textarea.");
    ui->textTo->setText( text );
    qDebug("Done.");
    qDebug("Any else?");
}






